<?php

/**
 * Implementation of hook_access()
 *
 */
function mdb_movie_access($op, $node) {

  global $user;

  if ($op == 'view' && user_access('view mdb_movie')) {
    return $node->status;
  }

  if ($op == 'create') {
    return user_access('create mdb_movie');
  }

  if ($op == 'update' || $op == 'delete') {
    if (user_access('edit own mdb_movie') && ($user->uid == $node->uid)) {
      return TRUE;
    }
  }
}
/**
 * Implementation of hook_insert()
 */
function mdb_movie_insert($node) {

  if (!$node->movietitle) { 
    $node->movietitle = $node->title; 
  }

  //Insert the data in the moviedb table
  db_query("INSERT INTO {moviedb} (nid, movietitle, releaseyear,  cover, runtime, country, language, imdb, amazon ) VALUES (%d, '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s')", $node->nid, $node->movietitle,  $node->releaseyear, $node->cover, $node->runtime,  $node->country, $node->language,  $node->imdb, $node->amazon);

  $jobs = moviedb_get_jobs();

  foreach ($jobs as $mdb_job) {
    $role_form = $mdb_job->job ."_form";
    moviedb_people_process($node->nid, $node->$role_form, $mdb_job);
  }

  for ($i = 0; $i < $node->numlinks; $i++) {
    $movielink = "movielink-$i";
    $linkdescription = "linkdescription-$i";
    if ($node->$movielink) {
      db_query("INSERT INTO {moviedb_links} (nid, movielink, description, weight) VALUES (%d, '%s', '%s', %d)", $node->nid, $node->$movielink, $node->$linkdescription, $i);
    }
  }

}

/**
 * Implementation of hook_load()
 *
 */
function mdb_movie_load($node) {
  
  $moviedb = db_fetch_object(db_query("SELECT * FROM {moviedb} WHERE nid = %d", $node->nid));

  $jobs = moviedb_get_jobs();
 
  foreach ($jobs as $mdb_job) {
        
    $role_form = $mdb_job->job ."_form";
    $role = $mdb_job->job;

    $role_load               = moviedb_people_load($node->nid, $mdb_job);
    $moviedb->$role          = $role_load['object'];
    $moviedb->$role_form     = $role_load['form'];
  }

  if (module_exists('taxonomy') && ($vid = variable_get('moviedb_genre_vocab', 0)) != 0) {
    $terms = taxonomy_node_get_terms_by_vocabulary($node->nid, $vid);
  }
  if ($terms) {
    $moviedb->genre         = $terms;
  }

/*

  $movielinks = db_query("SELECT movielink, description, weight FROM {moviedb_links} WHERE nid = '$node->nid' ORDER BY weight");
  while ($movielink = db_fetch_object($movielinks)) {
    $moviedb->movielinks[$movielink->weight] = $movielink->movielink;
    $moviedb->linkdescriptions[$movielink->weight] = $movielink->description;
  }
  $moviedb->numlinks = count($moviedb->movielinks);
*/
  return $moviedb;
}

/**
 * Implementation of hook_update()
 *
 */
function mdb_movie_update($node) {

  if (!$node->movietitle) { 
    $node->movietitle = $node->title;
  }

  //Update the moviedb table
  db_query("UPDATE {moviedb} SET movietitle = '%s', releaseyear = '%s', cover = '%s', runtime = '%s', country = '%s', language = '%s', imdb = '%s', amazon = '%s' WHERE nid = %d", $node->movietitle,  $node->releaseyear,  $node->cover, $node->runtime,  $node->country, $node->language,  $node->imdb, $node->amazon, $node->nid );

  $jobs = moviedb_get_jobs();

  foreach ($jobs as $mdb_job) {
    $role_table = $mdb_job->table_name;
    $role_form = $mdb_job->job ."_form";
    
    //Delete all the records from the actor links table
    if ($role_table == "moviedb_misc") {
      db_query("DELETE FROM {%s} WHERE mid = %d AND jid = %d", $role_table, $node->nid, $mdb_job->jid);
    } 
    else { 
      db_query("DELETE FROM {%s} WHERE mid = %d", $role_table, $node->nid);
    }
    //Add the actors
    moviedb_people_process($node->nid, $node->$role_form, $mdb_job);
  }

  db_query("DELETE FROM {moviedb_links} WHERE nid = %d", $node->nid);
  for ($i = 0; $i < $node->numlinks; $i++) {
    $movielink = "movielink-$i";
    $linkdescription = "linkdescription-$i";
    if ($node->$movielink) {
      db_query("INSERT INTO {moviedb_links} (nid, movielink, description, weight) VALUES (%d, '%s', '%s', %d)", $node->nid, $node->$movielink, $node->$linkdescription, $i);
    }
  }

}

/**
 * Implementation of hook_delete()
 *
 */
function mdb_movie_delete($node) {
  db_query("DELETE FROM {moviedb} WHERE nid = %d", $node->nid);

  $jobs = moviedb_get_jobs();

  foreach ($jobs as $mdb_job) {
    db_query("DELETE FROM {%s} WHERE mid = %d", $mdb_job->table_name, $node->nid);
  }

  db_query("DELETE FROM {moviedb_links} WHERE nid = %d", $node->nid);
}

/**
 * Implementation of hook_submit()
 *
 */
function mdb_movie_submit(&$node) {
}

/**
 * Implementation of validate()
 *
 */
function mdb_movie_validate(&$node) {
}

/**
 * Implementation of hook_form()
 *
 */
function mdb_movie_form(&$node) {

  $type = node_get_types('type', $node);

  if ($node->movielinks) {
    $node->numlinks = count($node->movielinks);
  }
  else {
    $node->numlinks = 3;
  }

  drupal_add_js('
var offlinks = '. $node->numlinks .';
function mdb_add_offsite() {
  numlinks = offlinks;
  speed = "slow";
  var linkcode;

  linkcode = "<tr><td><div class=\"form-item\"><label for=\"edit-movielink-"+numlinks+"\">URL: </label><input type=\"text\" maxlength=\"255\" name=\"movielink-"+numlinks+"\" id=\"edit-movielink-"+numlinks+"\"  size=\"45\" class=\"form-text\" /></div></td><td><div class=\"form-item\"><label for=\"edit-linkdescription-"+numlinks+"\">Description: </label><input type=\"text\" maxlength=\"255\" name=\"linkdescription-"+numlinks+"\" id=\"edit-linkdescription-"+numlinks+"\"  size=\"45\" class=\"form-text\" /></div></td></tr>";
  

  $("#offsite-links").append(linkcode);
  offlinks++;
}
', 'inline');

  $form['numlinks'] = array(
    '#type' => 'hidden',
    '#value' => $node->numlinks,
  );

  $form['title'] = array(
    '#type' => 'textfield',
    '#title' => check_plain($type->title_label),
    '#required' => TRUE,
    '#default_value' => $node->title,
    '#weight' => -5,
    '#size' => 60,
    '#maxlength' => 255,
    '#description' => t('The title of the movie being reviewed.'),
  );


  $form['general'] = array(
    '#type'         => 'fieldset',
    '#title'        => t('General Info'),
    '#collapsible'  => TRUE,
    '#weight'       => 1,

  );

  $form['general']['movietitle'] = array(
    '#type' => 'textfield',
    '#title' => t('Title for alphabetization'),
    '#default_value' => $node->movietitle,
    '#size' => 60,
    '#maxlength' => 255,
    '#description' => t('Title for alphabetization purposes. Friday the 13th: The Final Chapter becomes Friday the 13th 4, etc.')
  ); 

  $form['general']['releaseyear'] = array(
    '#type' => 'textfield',
    '#title' => t('Release year'),
    '#default_value' => $node->releaseyear,
    '#size' => 4,
    '#maxlength' => 2100,
    '#description' => t('The year the movie was released.  (Format:  YYYY).'),
  );


  $form['general']['cover'] = array(
    '#type' => 'textfield',
    '#title' => t('Cover picture'),
    '#default_value' => $node->cover,
    '#size' => 60,
    '#maxlength' => 255,
    '#description' => t('URL of movie cover image.'),
  );


  $form['general']['runtime'] = array(
    '#type' => 'textfield',
    '#title' => t('Runtime'),
    '#default_value' => $node->runtime,
    '#size' => 60,
    '#maxlength' => 255,
    '#description' => t('The movie run time.'),
  );

  $form['general']['country'] = array(
    '#type' => 'textfield',
    '#title' => t('Country'),
    '#default_value' => $node->country,
    '#size' => 60,
    '#maxlength' => 255,
    '#description' => t('Country of movie production.'),
  );

  $form['general']['language'] = array(
    '#type' => 'textfield',
    '#title' => t('Language'),
    '#default_value' => $node->language,
    '#size' => 60,
    '#maxlength' => 255,
    '#description' => t('Language of the movie.'),
  );

  $form['body_filter'] = array(
    '#type'         => 'fieldset',
    '#title'        => t('Review'),
    '#collapsible'  => TRUE,
    '#weight'       => 2,

  );

  $form['body_filter']['body'] = array(
    '#type' => 'textarea',
    '#title' => t('Body'),
    '#default_value' => $node->body,
    '#cols' => 50,
    '#rows' => 10,
    '#description' => t('A synopsis of the movie being reviewed.'),
  );

  $form['body_filter']['format'] = filter_form($node->format);

  $form['people'] = array(
    '#type'         => 'fieldset',
    '#title'        => t('People'),
    '#collapsible'  => TRUE,
    '#weight'       => 3,
  );

  $jobs = moviedb_get_jobs();

  foreach ($jobs as $mdb_job) {

    $role_form = $mdb_job->job ."_form";
    $role_title = ucfirst($mdb_job->plural);

    $form['people'][$role_form] = array(
      '#type'           => 'textfield',
      '#title'          => t($role_title),
      '#default_value'  => $node->$role_form,
      '#size'           => 60,
      '#maxlength'      => 5000,
      '#description'    => t($role_title .' of the performance. Comma separated.'),
      '#weight'         => $mdb_job->weight,
      '#autocomplete_path'  => 'moviedb/person/autocomplete',
    );
  }

  $form['people']['actor_form']['#description'] = t('Enter the names of the actors, comma separated. To include a character name, enter the actor\'s name then the character name preceded by two colons. Example:  Mel Gibson ::William Wallace, Tom Cruise ::Jerry Maguire, Angelina Jolie, Morgan Freeman ::Red');
  #$form['people']['actor_form']['#type'] = 'textarea';


  $form['links'] = array(
    '#type'         => 'fieldset',
    '#title'        => t('Links'),
    '#collapsible'  => TRUE,
    '#weight'       => 8,

  );

  $form['links']['imdb'] = array(
    '#type' => 'textfield',
    '#title' => t('Imdb'),
    '#default_value' => $node->imdb,
    '#size' => 60,
    '#maxlength' => 255,
    '#description' => t('Imdb id of the movie'),
  );

  $form['links']['amazon'] = array(
    '#type' => 'textfield',
    '#title' => t('Amazon'),
    '#default_value' => $node->amazon,
    '#size' => 60,
    '#maxlength' => 255,
    '#description' => t('Amazon ASIN of the movie'),
  );


  $form['links']['offsite_links'] = array(
    '#type' => 'fieldset',
    '#title' => t('Offsite links'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );

  $form['links']['offsite_links']['movielinks_begin'] = array(
      '#type' => 'markup',
      '#value' => '<table id="offsite-links">',
  );
  for ($i = 0; $i < $node->numlinks; $i++) {
    $form['links']['offsite_links']["movielink-$i"] = array(
      '#type' => 'textfield',
      '#title' => 'URL',
      '#default_value' => $node->movielinks[$i],
      '#size' => 45,
      '#maxlength' => 255,
      '#description' => '',
      '#prefix' => '<tr><td>',
      '#suffix' => '</td>',
    );
    $form['links']['offsite_links']["linkdescription-$i"] = array(
      '#type' => 'textfield',
      '#title' => 'Description',
      '#default_value' => $node->linkdescriptions[$i],
      '#size' => 45,
      '#maxlength' => 255,
      '#description' => '',
      '#prefix' => '<td>',
      '#suffix' => '</td></tr>',
    );
  }
  $form['links']['offsite_links']['movielinks_end'] = array(
      '#type' => 'markup',
      '#value' => '</table>',
  );

  $form['links']['offsite_links']['mdb_movie_more_links'] = array(
    '#type' => 'button',
    '#button_type' => 'offsite_but',
    '#name' => 'add_offsite',
    '#submit' => FALSE,
    '#value' => t('add more links'),
    '#attributes' => array('onclick' => 'mdb_add_offsite();return false;'),
  );

  return $form;

}